﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace RegexNumRangeTool
{
    internal class InternalTextBox : TextBox
	{
        private bool isTextChanged;
        private string oldText;
        private string newText;

        public InternalTextBox()
        {
            this.oldText = String.Empty;
            this.newText = String.Empty;
            this.GotFocus += new EventHandler(InternalTextBox_GotFocus);
            this.KeyDown += new KeyEventHandler(InternalTextBox_KeyDown);
            this.TextChanged += new EventHandler(InternalTextBox_TextChanged);
        }

        public bool IsTextChanged
        {
            get { return isTextChanged; }
        }

        public string OldText
        {
            get { return oldText; }
        }

        private void InternalTextBox_GotFocus(object sender, EventArgs e)
        {
            Select(0, TextLength);
        }

        private void InternalTextBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Modifiers == Keys.Control)
            {
                if (e.KeyCode == Keys.A)
                {
                    SelectAll();
                }
            }
        }

        private void InternalTextBox_TextChanged(object sender, EventArgs e)
        {
            if (Text == newText)
            {
                isTextChanged = false;
            }
            else
            {
                isTextChanged = true;
                oldText = newText;
                newText = Text;
            }
        }
	}
}
