﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Globalization;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace RegexNumRangeTool
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            textBox1.Text = "0";
            textBox1.TextChanged += new EventHandler(textBox1_TextChanged);
            textBox1.KeyDown += new KeyEventHandler(textBox1_KeyDown);

            textBox2.Text = "0";
            textBox2.TextChanged += new EventHandler(textBox2_TextChanged);
            textBox2.KeyDown += new KeyEventHandler(textBox2_KeyDown);
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Modifiers == Keys.None)
            {
                if (e.KeyCode == Keys.Enter)
                {
                    button1.PerformClick();
                }
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (TextHelper.Validate(textBox1.Text, TextHelper.IsDigit) != -1)
            {
                textBox1.Text = textBox1.OldText;
                textBox1.Select(textBox1.TextLength, 0);
            }
        }

        private void textBox2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Modifiers == Keys.None)
            {
                if (e.KeyCode == Keys.Enter)
                {
                    button1.PerformClick();
                }
            }
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            if (TextHelper.Validate(textBox2.Text, TextHelper.IsDigit) != -1)
            {
                textBox2.Text = textBox2.OldText;
                textBox2.Select(textBox2.TextLength, 0);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.TextLength == 0)
            {
                textBox1.Select();

                return;
            }

            if (textBox2.TextLength == 0)
            {
                textBox2.Select();

                return;
            }

            textBox1.Text = textBox1.Text.Remove(0, TextHelper.FindRep('0', textBox1.Text, 0, textBox1.Text.Length - 2));
            textBox2.Text = textBox2.Text.Remove(0, TextHelper.FindRep('0', textBox2.Text, 0, textBox2.Text.Length - 2));
            textBox3.Text = RegexNumRangeGen.Generate(textBox1.Text, textBox2.Text);
            textBox3.Select();
        }
    }
}
