﻿using System;
using System.Collections.Generic;
using System.Text;

namespace RegexNumRangeTool
{
    internal static class TextHelper
    {
        private static int[] charmap = new int[]
        {
            1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 0, 0,
            0, 0, 0, 0, 0, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,
            40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 32, 0, 48, 48, 48,
            48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
            48, 48, 48, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
        };
        private static int charmapLength = 160;

        public static bool IsDigit(char c)
        {
            return ((c < charmapLength) && ((charmap[c] & 4) != 0));
        }

        public static int IsDigit(string s)
        {
            return Validate(s, IsDigit);
        }

        public static int Validate(string str, Func<char, bool> validator)
        {
            int length = str.Length;

            for (int index = 0; index < length; index++)
            {
                if (!validator.Invoke(str[index]))
                {
                    return index;
                }
            }

            return -1;
        }

        public static int FindRep(char chr, string str, int beginPos, int endPos)
        {
            int pos;

            for (pos = beginPos; pos <= endPos; pos++)
            {
                if (str[pos] != chr)
                {
                    break;
                }
            }

            return pos - beginPos;
        }
    }
}
